<template>
  <div class="main-container fr-p-2w">
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <AtomAlert
      v-else-if="error"
      :alert-type="AlertType.Error"
      message="Les statistiques de la répartion des genres n'ont pas pu être chargées."
    />
    <template v-else-if="genderCounts">
      <h2 class="fr-h5">Genres</h2>
      <StatsPie
        v-if="genderCounts.length"
        pie-label="Répartion des genres"
        :stats="genderCounts"
        :total-count="beneficiaryCount"
      />
      <p v-else>
        Commencez à
        <NuxtLink
          :to="Routes.BeneficiariesAdd"
          target="_self"
          >créer des fiches de bénéficiaires</NuxtLink
        >
        pour voir apparaître les statistiques de la répartition des genres.
      </p>
    </template>
  </div>
</template>

<script setup>
  import { GENDER_OPTIONS } from '~/utils/constants/beneficiary'
  import { GENDER_COLORS } from '~/utils/constants/chart'
  import { AlertType } from '~~/utils/constants/alert'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { labelOrUnprovided } from '~~/utils/stats'
  import { Routes } from '~/utils/routing/routes'

  const { $getItems } = useNuxtApp()

  const props = defineProps({
    beneficiaryCount: {
      type: Number,
      required: true
    },
    filters: {
      type: Object,
      required: true
    }
  })

  const {
    data: genderCounts,
    pending,
    error,
    refresh
  } = useLazyAsyncData('genderCounts', loadGenderCounts, {
    server: false,
    default: () => 0
  })

  watch(() => props.filters, refresh)

  async function loadGenderCounts() {
    // NOTE: It is not using `count` agreggation due to a Directus bug - See https://github.com/directus/directus/discussions/16992
    const res = await $getItems('beneficiary', {
      groupBy: 'gender',
      aggregate: { countDistinct: 'id' },
      filter: props.filters
    })

    if (res.status === 200) {
      const genderCounts = res.data.data.map(({ gender, countDistinct }) => ({
        key: gender,
        label: labelOrUnprovided(gender, GENDER_OPTIONS),
        color: GENDER_COLORS[gender],
        count: parseInt(countDistinct.id)
      }))
      genderCounts.sort((a, b) => b.count - a.count)
      return genderCounts
    }
    throw new Error(errorResponseMessage(res))
  }
</script>
